/*------------
  border.cpp
  ------------*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>
#include <graphics.h>

#include "border.h"
#include "bar.h"

#include "oop_scan.h"

/*
 class BORDER
 */

//---------------------------------------------------------
BORDER::BORDER( int xx0, int yy0, int xx1, int yy1 )
{ if(xx0>xx1)
  { int x = xx0;
    xx0 = xx1;
    xx1 = x;
  }
  if(yy0>yy1)
  { int y = yy0;
    yy0 = yy1;
    yy1 = y;
  }
  if(xx0<0) xx0 = 0;
  if(yy0<0) yy0 = 0;
  if(xx1>getmaxx()) xx1 = getmaxx();
  if(yy1>getmaxy()) yy1 = getmaxy();

  x0 = mx0 = xx0;
  x1 = mx1 = xx1;
  y0 = my0 = yy0;
  y1 = my1 = yy1;

  left = right = NULL;
  top = bottom = NULL;
}

//---------------------------------------------------------
BORDER::~BORDER(void)
{ hide();
}

//---------------------------------------------------------
int BORDER::hide(void)
{ if( left    ) delete left;
  if( right   ) delete right;
  if( top     ) delete top;
  if( bottom  ) delete bottom;
  return Yes;
}

//---------------------------------------------------------
int BORDER::set_frontiers( int mmx0, int mmy0, int mmx1, int mmy1 )
{ hide();

  if(mmx0>mmx1)
  { int x = mmx0;
    mmx0 = mmx1;
    mmx1 = x;
  }
  if(mmy0>mmy1)
  { int y = mmy0;
    mmy0 = mmy1;
    mmy1 = y;
  }
  if(mmx0<0) mmx0 = 0;
  if(mmy0<0) mmy0 = 0;
  if(mmx1>getmaxx()) mmx1 = getmaxx();
  if(mmy1>getmaxy()) mmy1 = getmaxy();

  x0 = mx0 = mmx0;
  x1 = mx1 = mmx1;
  y0 = my0 = mmy0;
  y1 = my1 = mmy1;

  return show();
}

//---------------------------------------------------------
int BORDER::show(void) 
{
  left    = new VER_LINE(x0,y0+1,y1-1);
  right   = new VER_LINE(x1,y0+1,y1-1);
  top     = new HOR_LINE(x0,x1,y0);
  bottom  = new HOR_LINE(x0,x1,y1);
  left  ->show();
  right ->show();
  top   ->show();
  bottom->show();

  return Yes;
}

//---------------------------------------------------------
int BORDER::work(void)
{ int ox0 = x0;
  int oy0 = y0;
  int ox1 = x1;
  int oy1 = y1;
  BAR marker( x0, y0, x0+5, y0+5 );
  enum POS { LU, RD } pos = LU;
  int not_cancel = Yes;
  int what;
  int bye = No;
  int dx, dy;
  volatile char far * kbd = (char far *) MK_FP(0,0x417);
  do
  { show();
    marker.show();
    what = (bioskey(0)&0xff00)>>8;
    marker.hide();
    switch(what)
    { case ENTER: bye = Yes;
                  break;
      case ESC  : bye = Yes;
                  not_cancel = No;
                  x0 = ox0;
                  y0 = oy0;
                  x1 = ox1;
                  y1 = oy1;
                  break;
      case LEFT : dx = (*kbd & 3)? -big_step : -step;
                  if(pos==LU)
                  { if( x0+dx < mx0 ) dx = mx0 - x0;
                    x0 += dx;
                  }
                  else
                  { if( x1+dx <= x0 )  dx = x0 - x1;
                    x1 += dx;
                  }
                  marker.move(dx,0);
                  marker.hide();
                  break;
      case RIGHT: dx = (*kbd & 3)? big_step : step;
                  if(pos==LU)
                  { if( x0+dx >= x1 ) dx = x1 - x0;
                    x0 += dx;
                  }
                  else
                  { if( x1+dx > mx1 )  dx = mx1 - x1;
                    x1 += dx;
                  }
                  marker.move(dx,0);
                  marker.hide();
                  break;
      case UP   : dy = (*kbd & 3)? -big_step : -step;
                  if(pos==LU)
                  { if( y0+dy < my0 ) dy = my0 - y0;
                    y0 += dy;
                  }
                  else
                  { if( y1+dy <= y0 )  dy = y0 - y1;
                    y1 += dy;
                  }
                  marker.move(0,dy);
                  marker.hide();
                  break;
      case DOWN : dy = (*kbd & 3)? big_step : step;
                  if(pos==LU)
                  { if( y0+dy >= y1 ) dy = y1 - y0;
                    y0 += dy;
                  }
                  else
                  { if( y1+dy > my1 )  dy = my1 - y1;
                    y1 += dy;
                  }
                  marker.move(0,dy);
                  marker.hide();
                  break;
      case TAB  : if(pos==LU)
                  { pos = RD;
                    marker.move_to(x1-5,y1-5);
                    marker.hide();
                  }
                  else
                  { pos = LU;
                    marker.move_to(x0,y0);
                    marker.hide();
                  }
    }
    hide();
  } while(!bye);

  show();
  return not_cancel;
}
