/*-------------
  explorer.cpp
  -------------*/

#include <stdio.h>
#include <conio.h>
#include <bios.h>

#include "explorer.h"

#include "border.h"
#include "panel.h"

#include "oop_scan.h"

/*
 class EXPLORER
 */

//-----------------------------------------------------
int EXPLORER::work(void)
{ if(!mb.show()) return No;
  fflush(stdin);
  getch();
  PANEL panel(mb);
  BORDER * border;
  int bye = No;
  int key;
  int redraw = Yes;
  do
  { if(redraw) panel.show(panel.MAIN);
    key = (bioskey(0)&0xff00)>>8;
    switch(key)
    { case F2 : mb.save();
                redraw = No;
                break;
      case F3 : mb.init("?");
                redraw = Yes;
                break;
      case F4 : panel.show(panel.EDIT);
                border = new BORDER(0,0,mb.sizx,mb.sizy);
                if(border->work())
                { double del_x = ( mb.re - mb.rb ) / mb.sizx;
                  double del_y = ( mb.ie - mb.ib ) / mb.sizy;
                  double start_x = mb.rb;
                  mb.rb = start_x + border->is_x0() * del_x;
                  mb.re = start_x + border->is_x1() * del_x;
                  double start_y = mb.ib;
                  mb.ib = start_y + border->is_y0() * del_y;
                  mb.ie = start_y + border->is_y1() * del_y;
                }
                delete border;
                panel.show(panel.MAIN);
                redraw = Yes;
                break;
      case F5 : if(!mb.show()) return No;
                redraw = Yes;
                break;
      case F6 : panel.show(panel.METHOD);
                do
                { fflush(stdin);
                  switch(getch())
                  { case '1' : mb.art = OLD;
                               goto BREAK;
                    case '2' : mb.art = MODERN;
                               goto BREAK;
                    case '3' : mb.art = MIXED;
                               goto BREAK;
                    case 27  : goto BREAK;
                  }
                } while(Yes);
      case F7 : panel.show(panel.SIZE);
                do
                { fflush(stdin);
                  switch(getch())
                  { case '1' : mb.sizx = getmaxx()+1;
                               mb.sizy = getmaxy()+1;
                               goto BREAK;
                    case '2' : mb.sizx = mb.sizy = getmaxy()*3/4;
                               goto BREAK;
                    case '3' : mb.sizx = mb.sizy = getmaxy()*2/5;
                               goto BREAK;
                    case 27  : goto BREAK;
                  }
                } while(Yes);
      case F8 : panel.show(panel.ITERATIONS);
                do
                { fflush(stdin);
                  switch(getch())
                  { case '1' : mb.it = 100;
                               goto BREAK;
                    case '2' : mb.it = 150;
                               goto BREAK;
                    case '3' : mb.it = 250;
                               goto BREAK;
                    case '4' : mb.it = 500;
                               goto BREAK;
                    case '5' : mb.it = 1000;
                               goto BREAK;
                    case '6' : mb.it = 2000;
                               goto BREAK;
                    case 27  : goto BREAK;
                  }
                } while(Yes);
      BREAK   : panel.show(panel.MAIN);
                redraw = Yes;
                break;
      case F10: bye = Yes;
                break;
      default : redraw = No;
                break;
    }
  } while(!bye);

  return Yes;
}

