
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "mandelbr.h"
#include "explorer.h"

#ifndef Ok
#define Ok 1
#define Yes 1
#define No 0
#endif

void main(void)
{ puts( "\n"
        "Ŀ\n"
        "  The Beauty Of Fractals  \n"
        "      (c) V. 1992,94      \n"
        ""
      );

  puts( "\nChoose graphmode:\n"
        "\t0 - EGA\n"
        "\t1 - VGA\n"
        "\t2 - autodetect"
       );
  char c;
  do c=getch(); while( c<'0' || c>'3' );

  int gdriver, gmode, errorcode;
  switch(c)
  { case '0' : gmode=EGAHI;
               gdriver=EGA;
	       puts("640 x 350 16 color");
	       break;
    case '1' : gmode=VGAHI;
               gdriver=VGA;
	       puts("640 x 480 16 color");
	       break;
    case '2' : gdriver = DETECT;
	       puts("detecting ...");
               break;
  }

  initgraph(&gdriver, &gmode, "");
  errorcode = graphresult();

  if (errorcode != grOk)
  { printf("Graphics error: %s\n", grapherrormsg(errorcode));
    return;
  }

  char msg[80];
  sprintf(msg,"  %d x %d , %d colors",
              1+getmaxx(), 1+getmaxy(), 1+getmaxcolor());
  puts(msg);

  MANDELBROT mb;

  puts( "\nInput data from :\n"
        "\t0 - file FRACTAL.DAT\n"
        "\t1 - other file\n"
        "\t2 - console\n"
        "\t3 - default"
       );
  do c=getch(); while( c<'0' || c>'3' );
  int init_result;
  switch(c)
  { case '2': init_result = 2 * mb.init();
              break;
    case '0': init_result = mb.init("FRACTAL.DAT");
              break;
    case '1': init_result = mb.init("?");
              break;
    case '3': init_result = Yes;
              break;
    default:  putchar('\a');
  }

  if(!init_result)
  { puts( "Initialization failure\n"
          "...type any key to quit..."
        );
    getch();
  }
  else if(!mb.prompt())
  {
  }
  else
  { if( init_result == 2 * Yes )
    { puts("\nSave data in file (y/n) ?");
      char sc;
      do sc=toupper(getch()); while( sc!='Y' && sc!='N' );
      if(sc=='Y') mb.save();
    }
    EXPLORER ex(mb);
    if(!ex.work())
    { puts( "\n Mandelbrot Explorer : Incorrect input data !\n"
            "...type any key to quit..."
          );
      getch();
    }
  }

  closegraph();
}







