/* ------------------------------------------------
   Mandelbrot set
   z = z * z + c
   (C) 1992,94 by V.A.Voilevitch
---------------------------------------------------*/

#ifndef Ok
#define Ok 1
#define Yes 1
#define No 0
#endif

#ifndef __MANDELBROT__
#define __MANDELBROT__

#include <stdio.h>

enum DRAW_METHOD { OLD    = 0,
                   MODERN = 1,
                   MIXED  = 2
                 };
extern char *methods[];

class MANDELBROT
{
  friend class EXPLORER;
  friend class PANEL;

  private:
    //-----------------------------------------------------
    double      rb;       // start real  \
    double      re;       // end real      \  area of
    double      ib;       // start image   /  complex numbers
    double      ie;       // end image   /
    int         sizx;     // x size of picture in pixels
    int         sizy;     // y size of picture in pixels
    DRAW_METHOD art;
    int         backgr;   // background color
    int         it;       // total iterations
    int         st;       // first visible iteration
    int         ipc;      // iterations per color
    //-----------------------------------------------------

  public:
    //-----------------------------------------------------
    MANDELBROT(void);
    int show(void) const;
    int init(void);
    int init(char *filename);   // to enter name  "?"
    int range(void) const;
    int prompt(void);
    int save(char *filename = NULL);
    //-----------------------------------------------------

};

#endif
