/*------------
  panel.cpp
  ------------*/

#include <graphics.h>

#include "panel.h"


/*
 class PANEL
 */

//---------------------------------------------------------
PANEL::PANEL( MANDELBROT & __mb ) : mb(__mb)
{ left = getmaxx() * 3 / 4;
}


//---------------------------------------------------------
int PANEL::show(ITEM what)
{
  fillsettingstype  fillinfo;
  getfillsettings( &fillinfo );
  int oldcolor = getcolor();

  setfillstyle(SOLID_FILL, LIGHTGRAY);
  bar( left, 0, getmaxx(), getmaxy() );

  char msg[40];
  setcolor(BLACK);
  //---------------- status ----------
  put("    Area :",1);
  sprintf(msg,"Re %18.15lf",mb.rb);
  put(msg,2,0);
  sprintf(msg,"   %18.15lf",mb.re);
  put(msg,3,0);
  sprintf(msg,"Im %18.15lf",mb.ib);
  put(msg,4,0);
  sprintf(msg,"   %18.15lf",mb.ie);
  put(msg,5,0);
  put("    Picture :",7);
  sprintf(msg,"%d x %d",mb.sizx,mb.sizy);
  put(msg,8);
  put("    Method :",10);
  put(methods[mb.art],11);
  put("    Iterations :",13);
  if(mb.art==MIXED)
    sprintf(msg,"%d / %d / %d",mb.it, mb.st, mb.ipc);
  else
    sprintf(msg,"%d / %d /",mb.it, mb.st);
  put(msg,14);

  setfillstyle(SOLID_FILL, LIGHTBLUE);
  bar( left,        157,         getmaxx(), 160       );
  bar( left,        getmaxy()-3, getmaxx(), getmaxy() );
  bar( left,        157,         left+3,    getmaxy() );
  bar( getmaxx()-3, 157,         getmaxx(), getmaxy() );

  //---------------- keys ----------
  textsettingstype textinfo;
  gettextsettings(&textinfo);
  settextstyle(SANS_SERIF_FONT, HORIZ_DIR, 2);
  switch(what)
  { case MAIN : put("  MAIN :",17);
                put("F2  save",20);
                put("F3  load",22);
                put("F4  edit",24);
                put("F5  draw",26);
                put("F6  method",28);
                put("F7  size",30);
                put("F8  iterations",32);
                put("F10 exit",34);
                break;
    case EDIT : put("  EDIT :",17);
                put("<Shift>",20);
                put(" <Arrows>",22);
                put("   - edit",24);
                put("TAB -",26);
                put("  corner",28);
                put("ESC -",30);
                put("  cancel",32);
                put("Enter -",34);
                put("  o\'key",36);
                break;
    case METHOD:put("  METHOD:",17);
                put("1 - OLD",20);
                put("2 - MODERN",22);
                put("3 - MIXED",24);
                put("ESC cancel",26);
                break;
    case ITERATIONS :
                put(" ITERATIONS :",17);
                put("1 - 100",20);
                put("2 - 150",22);
                put("3 - 250",24);
                put("4 - 500",26);
                put("5 - 1000",28);
                put("6 - 2000",30);
                put("ESC cancel",32);
                break;
    case SIZE : put("  SIZE :",17);
                put("1 - ZOOM",20);
                put("2 - MIDDLE",22);
                put("3 - MINI",24);
                put("ESC cancel",26);
                break;
  }
  settextstyle(textinfo.font, textinfo.direction, textinfo.charsize);

  setfillstyle( fillinfo.pattern, fillinfo.color);
  setcolor(oldcolor);
  return Yes;
}

//---------------------------------------------------------
void PANEL::put( char * s, int row, int col)
{ outtextxy( left+col*10, row*10, s);
}
